#include-once
#include <GUIConstantsEx.au3>
#include <EditConstants.au3>
#include <SQLite.au3>
#include <Array.au3>
#include <ComboConstants.au3>
#include <WindowsConstants.au3>
#include <GuiListView.au3>
#include <CommMG.au3> ; http://www.autoitscript.com/forum/topic/128546-serial-port-com-port-udf/
#Include <UnixTime.au3> ; http://www.therks.com/autoit/udfs/UnixTime.au3

#NoTrayIcon

;         
Global Const $IniFile = "ussdsms.ini"
Global Const $Width = 0.71*@DesktopWidth
Global Const $Height = 0.9*@DesktopHeight
Global $B_DESCENDING


If Not FileExists ($IniFile) Then
	MsgBox (0+16, "", "     " & $IniFile)
	Exit -1
 EndIf

Local Const $LastOperator = IniRead ($IniFile, "General", "LastOperator", "unknown")
Local Const $FontName = IniRead ($IniFile, "General", "FontName", "unknown")
Local Const $FontSize = IniRead ($IniFile, "General", "FontSize", "unknown")
Local Const $FontWeight = IniRead ($IniFile, "General", "FontWeight", "unknown")
Local Const $FontAttribute = IniRead ($IniFile, "General", "FontAttribute", "unknown")

Local Const $COMPort = IniRead ($IniFile, "Modem", "COMPort", "unknown")
Local Const $BaudRate = IniRead ($IniFile, "Modem", "BaudRate", "unknown")
Local Const $AttemptsToGetResponse = IniRead ($IniFile, "Modem", "AttemptsToGetResponse", "unknown")
Local Const $WaitModemResponse = IniRead ($IniFile, "Modem", "WaitModemResponse", "unknown")

Local Const $DataBase = IniRead ($IniFile, "Database", "DataBase", "unknown")

Local Const $ReverseTransliteration = IniRead ($IniFile, "USSD", "ReverseTransliteration", "unknown")
Local Const $PlayUSSD = IniRead ($IniFile, "USSD", "PlayUSSD", "unknown")
Local Const $SoundUSSD = IniRead ($IniFile, "USSD", "SoundUSSD", "unknown")
Local Const $WaitUSSDResponse = IniRead ($IniFile, "USSD", "WaitUSSDResponse", "unknown")

Local Const $CheckSMS = IniRead ($IniFile, "SMS", "CheckSMS", "unknown")
Local Const $PlaySMS = IniRead ($IniFile, "SMS", "PlaySMS", "unknown")
Local Const $SoundSMS = IniRead ($IniFile, "SMS", "SoundSMS", "unknown")
Local Const $CheckSMSTimeout = IniRead ($IniFile, "SMS", "CheckSMSTimeout", "unknown")

If $DataBase = "unknown" Or $LastOperator = "unknown" Or $COMPort = "unknown" Or $BaudRate = "unknown" Or $PlayUSSD = "unknown" Or $SoundUSSD = "unknown" Or $PlaySMS = "unknown" Or $SoundSMS = "unknown" Or $AttemptsToGetResponse = "unknown" Or $WaitModemResponse = "unknown" Or $WaitUSSDResponse = "unknown" Or $CheckSMSTimeout = "unknown" Or $ReverseTransliteration = "unknown" Or $FontName = "unknown" Or $FontSize = "unknown" Or $FontWeight = "unknown" Or $FontAttribute = "unknown" Or $CheckSMS = "unknown" Then
	MsgBox (0+16, "", "    " & $IniFile)
	Exit -1
EndIf

Local $hDataBase = _SQLiteDataBaseOpen ($DataBase)
Local $aModemCommands = _GetInfoFromDataBase ("SELECT * FROM modem_commands;", True)
_COMPortOpen ()
Local $ModemType = _GetResponseFromModem ($aModemCommands[2][1])

Local $MainWindow = GUICreate("USSD  SMS: " & $ModemType, $Width, $Height)

Local $LabelChooseOperator = GUICtrlCreateLabel (" ", 0.015*$Width, 0.008*$Height, 0.12*$Width, 0.02*$Height)
Local $ComboChooseOperator = GUICtrlCreateCombo ("", 0.15*$Width, 0.005*$Height, 0.24*$Width, 0.016*$Height, BitOR ($CBS_DROPDOWNLIST, $WS_VSCROLL))
Local $InputAddOperator = GUICtrlCreateInput ("", 0.4*$Width, 0.005*$Height, 0.24*$Width, 0.03*$Height)
GUICtrlSetState (-1, $GUI_HIDE)
Local $ButtonAddOperator = GUICtrlCreateButton ("", 0.645*$Width, 0.005*$Height, 0.12*$Width, 0.03*$Height)
GUICtrlSetState (-1, $GUI_HIDE)
Local $ButtonReloadModem = GUICtrlCreateButton ("   COM ", 0.78*$Width, 0.005*$Height, 0.21*$Width, 0.03*$Height)

Local $LabelSignalLevel = GUICtrlCreateLabel (" ", 0.015*$Width, 0.05*$Height, 0.12*$Width, 0.02*$Height)
Local $ProgressBar = GUICtrlCreateProgress (0.12*$Width, 0.045*$Height, 0.5*$Width, 0.032*$Height)
Local $SignalStrenght = _GetResponseFromModem ($aModemCommands[3][1])
$SignalStrenght = StringTrimLeft ($SignalStrenght, StringInStr ($SignalStrenght, " "))
$SignalStrenght = StringTrimRight ($SignalStrenght, StringInStr ($SignalStrenght, ","))
$SignalStrenght = -113 + (2 * $SignalStrenght)
If $SignalStrenght < -113 Then $SignalStrenght = -113
If $SignalStrenght > -51 Then $SignalStrenght = -51
$SignalStrenght = Abs((-113 - $SignalStrenght)*1.6)
If $SignalStrenght = 99.2 Then $SignalStrenght = 100
GUICtrlSetData($ProgressBar, $SignalStrenght)

If StringInStr ($ModemType, "gobi") Then
	Local $LabelTemperature = GUICtrlCreateLabel (" ", 0.625*$Width, 0.05*$Height, 0.12*$Width, 0.02*$Height)
	Local $LabelTemperatureZnach = GUICtrlCreateLabel ("", 0.745*$Width, 0.05*$Height, 0.03*$Width, 0.02*$Height)
	GUICtrlSetFont (-1, 9, 800, 2)
	Local $LabelTemperatureEd = GUICtrlCreateLabel (".", 0.76*$Width, 0.05*$Height, 0.03*$Width, 0.02*$Height)
	Local $TempOfModem = _GetResponseFromModem ($aModemCommands[4][1])
	$TempOfModem = StringRegExpReplace ($TempOfModem, "[^0-9]+", "")
	GUICtrlSetData ($LabelTemperatureZnach, $TempOfModem)

	Local $LabelVoltage = GUICtrlCreateLabel ("", 0.8*$Width, 0.05*$Height, 0.07*$Width, 0.02*$Height)
	Local $LabelVoltageZnach = GUICtrlCreateLabel ("", 0.87*$Width, 0.05*$Height, 0.03*$Width, 0.02*$Height)
	GUICtrlSetFont (-1, 9, 800, 2)
	Local $LabelVoltageEd = GUICtrlCreateLabel ("", 0.902*$Width, 0.05*$Height, 0.03*$Width, 0.02*$Height)
	Local $VoltageOfModem = _GetResponseFromModem ($aModemCommands[5][1])
	$VoltageOfModem = StringRegExpReplace ($VoltageOfModem, "[^0-9]+", "")
	GUICtrlSetData ($LabelVoltageZnach, $VoltageOfModem / 1000)
EndIf

Local $USSDGroup = GUICtrlCreateGroup ("USSD", 0.015*$Width, 0.1*$Height, 0.475*$Width, 0.88*$Height)
Local $USSDQueriesCombo = GUICtrlCreateCombo ("", 0.02*$Width, 0.12*$Height, 0.465*$Width, 0.016*$Height, BitOR ($CBS_DROPDOWNLIST, $WS_VSCROLL))



Local $USSDLabelQueryInfo = GUICtrlCreateLabel ("  ID:", 0.02*$Width, 0.154*$Height, 0.09*$Width, 0.02*$Height)
Local $USSDLabelQueryID = GUICtrlCreateLabel ("?", 0.105*$Width, 0.153*$Height, 0.012*$Width, 0.02*$Height)
GUICtrlSetFont (-1, 9, 800, 2)
Local $USSDLabelQueryName = GUICtrlCreateLabel (":", 0.125*$Width, 0.154*$Height, 0.045*$Width, 0.02*$Height)
Local $USSDLabelQueryNameContent = GUICtrlCreateLabel ("", 0.169*$Width, 0.153*$Height, 0.26*$Width, 0.02*$Height)
GUICtrlSetFont (-1, 9, 800, 2)
Local $USSDLabelQueryUSSD = GUICtrlCreateLabel (":", 0.4*$Width, 0.154*$Height, 0.02*$Width, 0.02*$Height)

Local $USSDLabelQueryUSSDCode = GUICtrlCreateLabel ("", 0.42*$Width, 0.153*$Height, 0.06*$Width, 0.02*$Height)
GUICtrlSetFont (-1, 9, 800, 2)
Local $USSDQueryDescriptionLabel = GUICtrlCreateLabel (" USSD-", 0.03*$Width, 0.185*$Height, 0.14*$Width, 0.02*$Height)
Local $USSDQueryDescriptionInput = GUICtrlCreateInput ("", 0.17*$Width, 0.18*$Height, 0.31*$Width, 0.03*$Height)
Local $USSDQueryStringLabel = GUICtrlCreateLabel (" USSD-", 0.03*$Width, 0.225*$Height, 0.14*$Width, 0.02*$Height)
Local $USSDQueryStringInput = GUICtrlCreateInput ("", 0.17*$Width, 0.22*$Height, 0.31*$Width, 0.03*$Height)
Local $USSDQuerySendButton = GUICtrlCreateButton (" ", 0.03*$Width, 0.26*$Height, 0.14*$Width, 0.03*$Height)
GUICtrlSetState (-1, $GUI_FOCUS)
Local $USSDQuerySaveButton = GUICtrlCreateButton ("/", 0.18*$Width, 0.26*$Height, 0.14*$Width, 0.03*$Height)
Local $USSDQueryDeleteButton = GUICtrlCreateButton ("", 0.33*$Width, 0.26*$Height, 0.14*$Width, 0.03*$Height)
Local $USSDQueryEdit = GUICtrlCreateEdit ("", 0.03*$Width, 0.32*$Height, 0.45*$Width, 0.61*$Height, BitOR ($WS_VSCROLL, $ES_MULTILINE, $ES_READONLY), $WS_EX_STATICEDGE)
GUICtrlSetFont (-1, $FontSize, $FontWeight, $FontAttribute, $FontName)
Local $USSDSessionLabel = GUICtrlCreateLabel ("USSD  .  :", 0.03*$Width, 0.945*$Height, 0.24*$Width, 0.02*$Height)
GUICtrlSetState (-1, $GUI_HIDE)
Local $USSDSessionInput = GUICtrlCreateInput ("", 0.265*$Width, 0.941*$Height, 0.06*$Width, 0.03*$Height, $ES_NUMBER)
GUICtrlSetState (-1, $GUI_HIDE)
Local $USSDSessionButton = GUICtrlCreateButton (" ", 0.33*$Width, 0.941*$Height, 0.15*$Width, 0.03*$Height)
GUICtrlSetState (-1, $GUI_HIDE)
GUICtrlCreateGroup("", -99, -99, 1, 1)


Local $SMSGroup = GUICtrlCreateGroup ("SMS", 0.51*$Width, 0.1*$Height, 0.475*$Width, 0.88*$Height)
Local $SMSListView = GUICtrlGetHandle (GUICtrlCreateListView ("", 0.515*$Width, 0.12*$Height, 0.465*$Width, 0.36*$Height, $LVS_SHOWSELALWAYS))
_GUICtrlListView_SetExtendedListViewStyle($SMSListView, BitOR($LVS_EX_GRIDLINES, $LVS_EX_FULLROWSELECT, $LVS_EX_SUBITEMIMAGES))
_GUICtrlListView_InsertColumn($SMSListView, 0, "ID", 0.03*$Width)
_GUICtrlListView_InsertColumn($SMSListView, 1, "", 0.03*$Width)
_GUICtrlListView_InsertColumn($SMSListView, 2, "   ", 0.15*$Width)
_GUICtrlListView_InsertColumn($SMSListView, 3, "", 0.2*$Width)
Local $SMSDeleteButton = GUICtrlCreateButton (" ", 0.66*$Width, 0.485*$Height, 0.18*$Width, 0.04*$Height)
Local $SMSEdit = GUICtrlCreateEdit ("", 0.515*$Width, 0.53*$Height, 0.465*$Width, 0.44*$Height, BitOR ($WS_VSCROLL, $ES_MULTILINE, $ES_READONLY), $WS_EX_STATICEDGE)
GUICtrlSetFont (-1, $FontSize, $FontWeight, $FontAttribute, $FontName)
GUICtrlCreateGroup("", -99, -99, 1, 1)

_RefreshUSSDGUIElements ($LastOperator)
_RefreshSMSGUIElements ()

GUIRegisterMsg($WM_COMMAND, "WM_COMMAND")
GUIRegisterMsg($WM_NOTIFY, "WM_NOTIFY")

GUISetState(@SW_SHOW, $MainWindow)

$hSMSCheckTimer = TimerInit ()
While 1
	If TimerDiff($hSMSCheckTimer) > $CheckSMSTimeout Then
		If $CheckSMS = 1 Then _CheckSMS ()
		$hSMSCheckTimer = TimerInit ()
	EndIf
	
	$msg = GUIGetMsg ()
	Select
		Case $msg = $GUI_EVENT_CLOSE
			_ExitProg ()
			
		Case $msg = $ButtonAddOperator
			$AddOperatorZnach = GUICtrlRead ($InputAddOperator)
			If $AddOperatorZnach <> "" Then
				_GetInfoFromDataBase ("INSERT INTO operators (name) VALUES ('" & $AddOperatorZnach & "');")
				_RefreshUSSDGUIElements ($AddOperatorZnach)
			 EndIf
			GUICtrlSetData($InputAddOperator, "")
			GUICtrlSetState ($InputAddOperator, $GUI_HIDE)
			GUICtrlSetState ($ButtonAddOperator, $GUI_HIDE)
			
		Case $msg = $ButtonReloadModem
			_USSDCloseSession ()
			For $i = 1 to 10
				_CommCloseport()
			Next
			_COMPortOpen ()
			
		Case $msg = $USSDQuerySendButton
			_SendUSSDQuery (GUICtrlRead ($USSDQueryStringInput))
			
		Case $msg = $USSDQuerySaveButton
			_SaveOrChangeUSSDQuery ()
			
		Case $msg = $USSDQueryDeleteButton
			_DeleteUSSDQuery ()
			
		Case $msg = $USSDSessionButton
			_USSDCloseSession ()
			
		Case $msg = $SMSDeleteButton
			$aRowsSelected = _GUICtrlListView_GetSelectedIndices($SMSListView, True)
			If $aRowsSelected[0] <> 0 Then
				For $i = 1 to UBound ($aRowsSelected) - 1
					_GetInfoFromDataBase ("DELETE FROM sms WHERE id = " & _GUICtrlListView_GetItemText ($SMSListView, $aRowsSelected[$i], 0) & ";")
				Next
				_RefreshSMSGUIElements ()
			EndIf
	EndSelect
WEnd

Func WM_NOTIFY($hWnd, $iMsg, $iwParam, $ilParam)
	$hWndSMSListView = $SMSListView
	If Not IsHWnd($SMSListView) Then $hWndSMSListView = GUICtrlGetHandle($SMSListView)

	$tNMHDR = DllStructCreate($tagNMHDR, $ilParam)
	$hWndFrom = HWnd(DllStructGetData($tNMHDR, "hWndFrom"))
	$iIDFrom = DllStructGetData($tNMHDR, "IDFrom")
	$iCode = DllStructGetData($tNMHDR, "Code")

	Switch $hWndFrom
		Case $hWndSMSListView
			Switch $iCode
				Case $NM_CLICK
					$tInfo = DllStructCreate($tagNMITEMACTIVATE, $ilParam)
					$iIndexOfSelectedRow = DllStructGetData($tInfo, "Index")
					$SMSSelectedID = _GUICtrlListView_GetItemText($hWndSMSListView, $iIndexOfSelectedRow, 0)
					GUICtrlSetData ($SMSEdit, "")
					GUICtrlSetData ($SMSEdit, _GetInfoFromDataBase ("SELECT body FROM sms WHERE id = '" & $SMSSelectedID & "'"))
					_GetInfoFromDataBase ("UPDATE sms SET isnew = 'N' WHERE id = " & $SMSSelectedID & ";")
					_GUICtrlListView_SetItemText($hWndSMSListView, $iIndexOfSelectedRow, "N", 1)
				Case $LVN_COLUMNCLICK
					$tInfo = DllStructCreate($tagNMLISTVIEW, $ilParam)
					_GUICtrlListView_SimpleSort($hWndSMSListView, $B_DESCENDING, DllStructGetData($tInfo, "SubItem"))
			EndSwitch
	EndSwitch
	Return $GUI_RUNDEFMSG
EndFunc ; WM_NOTIFY

Func _RefreshSMSGUIElements ()
	_GUICtrlListView_DeleteAllItems($SMSListView)
	$aAllSMSFromDataBase = _GetInfoFromDataBase ("SELECT id, isnew, strftime('%d.%m.%Y %H:%M:%S', datetime(unix_datetime, 'unixepoch')) AS date_time, sender FROM (SELECT id, isnew, unix_datetime, sender FROM sms ORDER BY unix_datetime DESC);", True)
	If IsArray ($aAllSMSFromDataBase) Then
		GUICtrlSetData ($SMSEdit, "")
		_GUICtrlListView_AddArray($SMSListView, $aAllSMSFromDataBase)
	EndIf
EndFunc ; _RefreshSMSGUIElements

Func _CheckSMS ()
	$sSMSList = _GetResponseFromModem ($aModemCommands[8][1])
	If $sSMSList <> 1 Then
		Local $aSMSConsolidated[1][2]
		$aSMSListNumbers = StringRegExp ($sSMSList, "(?m)^\+CMGL:\ ([0-9]+)", 3)
		For $i = 0 To UBound ($aSMSListNumbers) - 1
			$SMSReceived = _GetResponseFromModem (StringReplace ($aModemCommands[9][1], "%", $aSMSListNumbers[$i]))
			_GetResponseFromModem (StringReplace ($aModemCommands[10][1], "%", $aSMSListNumbers[$i])) ;  SMS
			$aSMSParsed = StringRegExp ($SMSReceived, '(?mU)^\+CMGR:\ \".*\",(.*)\r\n(.*)$', 1)
			Local $iIndexOfAlreadyWrittenSMS = _ArraySearch ($aSMSConsolidated, $aSMSParsed[0])
			If $iIndexOfAlreadyWrittenSMS = -1 Then
				ReDim $aSMSConsolidated[UBound ($aSMSConsolidated)+1][2]
				$aSMSConsolidated[UBound ($aSMSConsolidated)-1][0] = $aSMSParsed[0]
				$aSMSConsolidated[UBound ($aSMSConsolidated)-1][1] = $aSMSParsed[1]
			Else
				$aSMSConsolidated[$iIndexOfAlreadyWrittenSMS][1] &= $aSMSParsed[1]
			EndIf
		Next

		_ArrayDelete ($aSMSConsolidated, 0)

		For $i = 0 to UBound ($aSMSConsolidated) - 1
			$aSMSSenderAndDateTime = StringRegExp ($aSMSConsolidated[$i][0], '(?U)^"(.*)",,"([0-9]+)\/([0-9]+)\/([0-9]+)\,([0-9]+)\:([0-9]+)\:([0-9]+)\+([0-9]+)\"$', 1)
			If _StringIsUSC2 ($aSMSSenderAndDateTime[0]) Then $aSMSSenderAndDateTime[0] = _PDU_UCS2_ASCII ($aSMSSenderAndDateTime[0])
			$TimeAndDateOfSMS = _TimeMakeStamp ($aSMSSenderAndDateTime[6], $aSMSSenderAndDateTime[5], $aSMSSenderAndDateTime[4], $aSMSSenderAndDateTime[3], $aSMSSenderAndDateTime[2], "20" & $aSMSSenderAndDateTime[1])
			$TimeAndDateOfSMS += $aSMSSenderAndDateTime[7] * 900
			If _StringIsUSC2 ($aSMSConsolidated[$i][1]) Then $aSMSConsolidated[$i][1] = _PDU_UCS2_ASCII ($aSMSConsolidated[$i][1])
			$aSMSConsolidated[$i][1] = StringReplace ($aSMSConsolidated[$i][1], "'", "")
			
			
			$aCheckExistingSMSInDataBase = _GetInfoFromDataBase ("SELECT id, body FROM sms WHERE (unix_datetime = '" & $TimeAndDateOfSMS & "' OR unix_datetime = '" & $TimeAndDateOfSMS - 1 & "') AND sender = '" & $aSMSSenderAndDateTime[0] & "';", True)
			If IsArray ($aCheckExistingSMSInDataBase) Then
				_GetInfoFromDataBase ("UPDATE sms SET isnew = 'Y', unix_datetime = '" & $TimeAndDateOfSMS & "', body = '" & $aCheckExistingSMSInDataBase[0][1] & $aSMSConsolidated[$i][1] & "' WHERE id = " & $aCheckExistingSMSInDataBase[0][0] & ";")
			Else
				_GetInfoFromDataBase ("INSERT INTO sms (isnew, unix_datetime, sender, body) VALUES ('Y', '" & $TimeAndDateOfSMS & "', '" & $aSMSSenderAndDateTime[0] & "', '" & $aSMSConsolidated[$i][1] & "');")
			EndIf
		Next

		_RefreshSMSGUIElements ()
		If $PlaySMS = 1 And StringInStr ($sSMSList, "+CMGL: ") Then SoundPlay ($SoundSMS)
	EndIf
EndFunc ; _CheckSMS 

Func _StringIsUSC2 ($sStringToCheck)
	If Mod (StringLen ($sStringToCheck), 4) = 0 And StringRegExp ($sStringToCheck, "^[A-F0-9]+$", 0) = 1 Then Return True
	Return False
EndFunc ; _StringIsUSC2

Func _PDU_UCS2_ASCII($s) ; UCS2  .
	Local $result
	For $i=1 To StringLen($s) Step 4
		$k=Dec(StringMid($s,$i,4))
		If $k=1025 Then
			$k=168 ;
		ElseIf $k=1105 Then
			$k=184 ;
		ElseIf $k>=1040 Then
			$k-=848 ;~  $k=$k-1040+192
		EndIf
		$result&=Chr($k)
	Next
	Return $result
EndFunc ; _PDU_UCS2_ASCII

Func _USSDCloseSession ()
	_GetResponseFromModem ($aModemCommands[7][1])
	_ChangeUSSDGUIElementsStatus ("Enable")
EndFunc ; _USSDCloseSession

Func _DeleteUSSDQuery ()
	$CurrentUSSDID = GUICtrlRead ($USSDLabelQueryID)
	If $CurrentUSSDID = "?" Then
		GUICtrlSetData ($USSDQueryDescriptionInput, "")
		GUICtrlSetData ($USSDQueryStringInput, "")
	Else
		_GetInfoFromDataBase ("DELETE FROM ussd_queries WHERE id = " & $CurrentUSSDID & ";")
		GUICtrlSetData ($USSDLabelQueryID, "?")
		GUICtrlSetData ($USSDLabelQueryNameContent, "")
		GUICtrlSetData ($USSDLabelQueryUSSDCode, "")
	EndIf
	_RefreshUSSDGUIElements (GUICtrlRead ($ComboChooseOperator))
EndFunc ; _DeleteUSSDQuery

Func _SaveOrChangeUSSDQuery ()
	$CurrentUSSDID = GUICtrlRead ($USSDLabelQueryID)
	$fUSSDDescription = GUICtrlRead ($USSDQueryDescriptionInput)
	$fUSSDString = GUICtrlRead ($USSDQueryStringInput)
	If $fUSSDDescription = "" Or Not StringRegExp ($fUSSDString, "^\*[0-9]+[\*\#0-9]+$") Then Return -1
	
	If $CurrentUSSDID = "?" Then
		_GetInfoFromDataBase ("INSERT INTO ussd_queries (operator_id, description, query) VALUES (" & $iIDOfOperator & ", '" & $fUSSDDescription & "', '" & $fUSSDString & "');")
	Else
		_GetInfoFromDataBase ("UPDATE ussd_queries SET description='" & $fUSSDDescription & "', query='" & $fUSSDString & "' WHERE id = " & $CurrentUSSDID & ";")
		
	EndIf
	_RefreshUSSDGUIElements (GUICtrlRead ($ComboChooseOperator))
EndFunc ; _SaveOrChangeUSSDQuery

Func _SendUSSDQuery ($sfQuery)
	If Not StringRegExp ($sfQuery, "^[0-9\*\#]+$") Then Return -1
	$sQueryToSend = StringReplace ($aModemCommands[6][1], "%", $sfQuery)
	$sUSSDResponse = _GetResponseFromModem ($sQueryToSend, True)
	If $sUSSDResponse <> -1 Then
		$aUSSDResponse = StringRegExp ($sUSSDResponse, '(?sm)^\+CUSD\:\ ([0-9]+),"(.*)",[0-9]+$', 1)
		If $aUSSDResponse[0] = 1 Then
			_ChangeUSSDGUIElementsStatus ("Disable")
			GUICtrlSetState ($USSDSessionInput, $GUI_FOCUS)
		Else
			_ChangeUSSDGUIElementsStatus ("Enable")
		EndIf
		If $PlayUSSD = 1 Then SoundPlay ($SoundUSSD)
		If $ReverseTransliteration = 1 Then $aUSSDResponse[1] = _ReverseTransliterateUSSDResponse ($aUSSDResponse[1])
		GUICtrlSetData ($USSDQueryEdit, "")
		GUICtrlSetData ($USSDQueryEdit, $aUSSDResponse[1])
		
	EndIf
EndFunc ; _SendUSSDQuery

Func _ChangeUSSDGUIElementsStatus ($fStatus, $fFull = True)
	If $fStatus = "Enable" Then
		If $fFull = True Then
			GUICtrlSetState ($USSDSessionLabel, $GUI_HIDE)
			GUICtrlSetState ($USSDSessionInput, $GUI_HIDE)
			GUICtrlSetState ($USSDSessionButton, $GUI_HIDE)
			GUICtrlSetState ($ComboChooseOperator, $GUI_ENABLE)
		EndIf
		GUICtrlSetState ($USSDQueriesCombo, $GUI_ENABLE)
		GUICtrlSetState ($USSDQueryDescriptionInput, $GUI_ENABLE)
		GUICtrlSetState ($USSDQueryStringInput, $GUI_ENABLE)
		GUICtrlSetState ($USSDQuerySendButton, $GUI_ENABLE)
		GUICtrlSetState ($USSDQuerySaveButton, $GUI_ENABLE)
		GUICtrlSetState ($USSDQueryDeleteButton, $GUI_ENABLE)
	ElseIf $fStatus =  "Disable" Then
		If $fFull = True Then
			GUICtrlSetState ($USSDSessionLabel, $GUI_SHOW)
			GUICtrlSetState ($USSDSessionInput, $GUI_SHOW)
			GUICtrlSetState ($USSDSessionButton, $GUI_SHOW)
			GUICtrlSetState ($ComboChooseOperator, $GUI_DISABLE)
		EndIf
		GUICtrlSetState ($USSDQueriesCombo, $GUI_DISABLE)
		GUICtrlSetState ($USSDQueryDescriptionInput, $GUI_DISABLE)
		GUICtrlSetState ($USSDQueryStringInput, $GUI_DISABLE)
		GUICtrlSetState ($USSDQuerySendButton, $GUI_DISABLE)
		GUICtrlSetState ($USSDQuerySaveButton, $GUI_DISABLE)
		GUICtrlSetState ($USSDQueryDeleteButton, $GUI_DISABLE)
	EndIf
EndFunc ; _ChangeUSSDGUIElementsStatus

Func _ReverseTransliterateUSSDResponse ($sStringToTransliterate)
	Local $aReverseTranslitTable[30][2] = [["a", ""], ["b", ""], ["v", ""], ["g", ""], ["d", ""], ["e", ""], ["zh", ""], ["z", ""], ["i", ""], ["j", ""], ["k", ""], ["l", ""], ["m", ""], ["n", ""], ["o", ""], ["p", ""], ["r", ""], ["s", ""], ["t", ""], ["u", ""], ["f", ""], ["h", ""], ["c", ""], ["ch", ""], ["sh", ""], ["sch", ""], ["y", ""], ["'", ""], ["yu", ""], ["ja", ""]]

	For $q = 3 To 1 Step -1
		Local $iNumOfLettersToCheck = $q
		Local $aPositionsInString[1]
		Local $aIndexOfTable[1]
		Local $aUpperOrLower[1]
		For $i = 1 to StringLen ($sStringToTransliterate)
			$LettersCombinationToFind = StringMid ($sStringToTransliterate, $i, $iNumOfLettersToCheck)
			$iIndexOfFoundLettersCombination = _ArraySearch ($aReverseTranslitTable, $LettersCombinationToFind)
			If $iIndexOfFoundLettersCombination <> -1 Then
				_ArrayAdd ($aPositionsInString, $i)
				_ArrayAdd ($aIndexOfTable, $iIndexOfFoundLettersCombination)
				_ArrayAdd ($aUpperOrLower, StringIsUpper (StringMid ($sStringToTransliterate, $i, 1)))
			EndIf
		Next

		_ArrayDelete ($aPositionsInString, 0)
		_ArrayDelete ($aIndexOfTable, 0)
		_ArrayDelete ($aUpperOrLower, 0)

		For $i = 0 to UBound ($aPositionsInString) - 1
			$iPositionInString = $aPositionsInString[$i] - $i * ($iNumOfLettersToCheck - 1)
			$sFirstPartOfString = StringLeft ($sStringToTransliterate, $iPositionInString - 1)
			$sSecondPartOfString = StringMid ($sStringToTransliterate, $iPositionInString + $iNumOfLettersToCheck)
			$sLetterToAdd = $aReverseTranslitTable[$aIndexOfTable[$i]][1]
			If $aUpperOrLower[$i] = 1 Then $sLetterToAdd = StringUpper ($sLetterToAdd)
			$sStringToTransliterate = $sFirstPartOfString & $sLetterToAdd & $sSecondPartOfString
		Next
	Next

	Return $sStringToTransliterate
EndFunc ; _ReverseTransliterateUSSDResponse

Func _GetResponseFromModem ($fModemCommand, $WaitForUSSD = False)
	_CommSendString($fModemCommand & @CR, 1)
	For $i = 1 to $AttemptsToGetResponse
		$ModemResponse = _GetResponseFromModem2 ()
		If $ModemResponse <> "FALSE" Then
			ExitLoop
		Else
			For $x = 1 to 10
				_CommCloseport()
			Next
			_COMPortOpen ()
		EndIf
	Next
	
	If Not StringInStr ($ModemResponse, @CRLF & "OK" & @CRLF, 0, -1) Then
		Return -1
	Else
		$ModemResponse = StringRegExpReplace ($ModemResponse, "^" & StringReplace (StringReplace ($fModemCommand, "+", "\+"), "*", "\*") & "[\r\n]+", "")
		$ModemResponse = StringRegExpReplace ($ModemResponse, "[\r\n]*OK[\r\n]*$", "")
		If $WaitForUSSD = False Then
			If $ModemResponse = "" Then Return 1
			Return $ModemResponse
		Else
			Local $USSDResponse = ""
			Local $hTimer = TimerInit ()
			While 1
				Local $instr = _CommGetString ()
				If $instr <> "" Then
					$USSDResponse &= $instr
					If StringRegExp ($USSDResponse, '(?sm)^\+CUSD\:\s+[0-9]+,".*",[0-9]+', 0) = 1 Then ExitLoop
				EndIf
				If TimerDiff ($hTimer) > $WaitUSSDResponse Then
					$USSDResponse = "FALSE"
					ExitLoop
				EndIf
			WEnd
			If $USSDResponse = "FALSE" Then Return -1
			$USSDResponse = StringRegExpReplace ($USSDResponse, "^[\r\n]*", "")
			$USSDResponse = StringRegExpReplace ($USSDResponse, "[\r\n]*$", "")
			Return $USSDResponse
		EndIf
	 EndIf
EndFunc ; _GetResponseFromModem

Func _GetResponseFromModem2 ()
	$ModemResponse2 = ""
	Local $hTimer = TimerInit ()
	While 1
		Local $instr = _CommGetString ()
		If $instr <> "" Then
			$ModemResponse2 &= $instr
			If StringInStr ($ModemResponse2, @CRLF & "OK" & @CRLF, 0, -1) Then
				ExitLoop
			EndIf
		EndIf
		If TimerDiff ($hTimer) > $WaitModemResponse Then
			$ModemResponse2 = "FALSE"
			ExitLoop
		EndIf
	WEnd
	Return $ModemResponse2
EndFunc ; ==> _GetResponseFromModem2 ()

Func _COMPortOpen ()
	_CommSetPort($COMPort, "", $BaudRate, 8, 0, 1, 1)
	_GetResponseFromModem ($aModemCommands[0][1])
	_GetResponseFromModem ($aModemCommands[1][1])
EndFunc ; _COMPortOpen

Func _RefreshUSSDGUIElements ($fAddOperatorZnach)
	Global $aOperators = _GetInfoFromDataBase ("SELECT * FROM operators;", True)
	If _ArraySearch ($aOperators, $fAddOperatorZnach) = -1 Then
		MsgBox (0+16, "", " ")
		_SQLite_Close($hDataBase)
		_SQLite_Shutdown()
		Exit -1
	Else
		Global $iIDOfOperator = $aOperators[_ArraySearch ($aOperators, $fAddOperatorZnach)][0]
	EndIf

	GUICtrlSetData($ComboChooseOperator, "")
	Local $ComboChooseOperatorString = "|"

	For $i = 0 to UBound ($aOperators) - 1
		$ComboChooseOperatorString &= $aOperators[$i][1] & "|"
	Next
	$ComboChooseOperatorString = StringTrimRight ($ComboChooseOperatorString, 1)
	GUICtrlSetData($ComboChooseOperator, $ComboChooseOperatorString, $fAddOperatorZnach)
	
	
	Global $aSavedUSSDQueries = _GetInfoFromDataBase ("SELECT id, description, query FROM ussd_queries WHERE operator_id = " & $iIDOfOperator & ";", True)

	GUICtrlSetData($USSDQueriesCombo, "")
	Local $USSDQueriesComboString = " |"
	For $i = 0 to UBound ($aSavedUSSDQueries) - 1
		$USSDQueriesComboString &= $aSavedUSSDQueries[$i][1] & "|"
	Next
	$USSDQueriesComboString = StringTrimRight ($USSDQueriesComboString, 1)
	GUICtrlSetData($USSDQueriesCombo, $USSDQueriesComboString, " ")
	
	GUICtrlSetData ($USSDQueryDescriptionInput, "")
	GUICtrlSetData ($USSDQueryStringInput, "")
	GUICtrlSetData ($USSDLabelQueryID, "?")
	GUICtrlSetData ($USSDLabelQueryNameContent, "")
	GUICtrlSetData ($USSDLabelQueryUSSDCode, "")

	_ChangeUSSDGUIElementsStatus ("Enable", False)
EndFunc ; _RefreshUSSDGUIElements ()

Func WM_COMMAND ($hWnd, $iMsg, $iWparam, $iLparam)
	$hWndComboChooseOperator = $ComboChooseOperator
	If Not IsHWnd($ComboChooseOperator) Then $hWndComboChooseOperator = GUICtrlGetHandle($ComboChooseOperator)

	$hWndUSSDQueriesCombo = $USSDQueriesCombo
	If Not IsHWnd($USSDQueriesCombo) Then $hWndUSSDQueriesCombo = GUICtrlGetHandle($USSDQueriesCombo)
	

	$hWndUSSDSessionInput = $USSDSessionInput
	If Not IsHWnd($USSDSessionInput) Then $hWndUSSDSessionInput = GUICtrlGetHandle($USSDSessionInput)

	$nNotifyCode = BitShift($iwParam, 16)
	$nID = BitAND($iwParam, 0x0000FFFF)
	$hWndFrom = $ilParam
	$iIDFrom = BitAND($iwParam, 0xFFFF)
	$iCode = BitShift($iwParam, 16)
	
	Switch $hWndFrom
		Case $hWndUSSDSessionInput
			Switch $iCode
				Case $EN_CHANGE
					$USSDSessionDigitalCommand =  GUICtrlRead ($USSDSessionInput)
					Sleep (80)
					GUICtrlSetData ($USSDSessionInput, "")
					_SendUSSDQuery ($USSDSessionDigitalCommand)
					GUICtrlSetState ($USSDSessionInput, $GUI_FOCUS)
			EndSwitch
	
		Case $hWndComboChooseOperator
			Switch $iCode
				Case $CBN_SELCHANGE
					GUICtrlSetState ($InputAddOperator, $GUI_HIDE)
					GUICtrlSetState ($ButtonAddOperator, $GUI_HIDE)
					Local $ComboZnach = GUICtrlRead ($ComboChooseOperator)
					If $ComboZnach = "" Then
						GUICtrlSetState ($InputAddOperator, $GUI_SHOW)
						GUICtrlSetState ($InputAddOperator, $GUI_FOCUS)
						GUICtrlSetState ($ButtonAddOperator, $GUI_SHOW)
						_ChangeUSSDGUIElementsStatus ("Disable", False)
					 Else
						IniWrite ($IniFile, "General", "LastOperator", $ComboZnach)
						_RefreshUSSDGUIElements ($ComboZnach)
					EndIf
			EndSwitch
		Case $hWndUSSDQueriesCombo
			Switch $iCode
			Case $CBN_SELCHANGE
					Global $USSDQueryDescription = GUICtrlRead ($USSDQueriesCombo)
					If $USSDQueryDescription <> " " Then
						Global $iUSSDQueryRow = _ArraySearch ($aSavedUSSDQueries, $USSDQueryDescription)
						Global $USSDQueryString = $aSavedUSSDQueries[$iUSSDQueryRow][2]
						GUICtrlSetData ($USSDQueryDescriptionInput, $USSDQueryDescription)
						GUICtrlSetData ($USSDQueryStringInput, $USSDQueryString)
						GUICtrlSetData ($USSDLabelQueryID, $aSavedUSSDQueries[$iUSSDQueryRow][0])
						GUICtrlSetData ($USSDLabelQueryNameContent, $USSDQueryDescription)
						GUICtrlSetData ($USSDLabelQueryUSSDCode, $USSDQueryString)
;~ 						_SendUSSDQuery ($USSDQueryString)
					Else
						GUICtrlSetData ($USSDLabelQueryID, "?")
						GUICtrlSetData ($USSDLabelQueryNameContent, "")
						GUICtrlSetData ($USSDLabelQueryUSSDCode, "")
						GUICtrlSetData ($USSDQueryDescriptionInput, "")
						GUICtrlSetData ($USSDQueryStringInput, "")
					EndIf
			EndSwitch
	EndSwitch
	Return $GUI_RUNDEFMSG
EndFunc ; ==> WM_COMMAND

Func _SQLiteDataBaseOpen ($fDataBase)
	_SQLite_Startup()
	If @error Then
		MsgBox(16, " SQLite", "SQLite.dll    !")
		Exit -1
	EndIf
	Return _SQLite_Open($fDataBase)
EndFunc ; _SQLiteDataBaseOpen 

Func _GetInfoFromDataBase ($Query, $GetArray = False, $ShowFirstRow=False)
	If $GetArray = False Then
		Local $hQuery, $aRow, $foo
		_SQLite_Query ($hDataBase, $Query,  $hQuery)
		While _SQLite_FetchData ($hQuery, $aRow) = $SQLITE_OK
			$foo = $aRow[0]
		WEnd
		Return $foo
	ElseIf $GetArray = True Then
		Local $aResult, $iRows, $iColumns, $iRval
		$iRval = _SQLite_GetTable2d ($hDataBase, $Query, $aResult, $iRows, $iColumns)
		If $iRval = $SQLITE_OK Then
			If $ShowFirstRow=False Then
				_ArrayDelete ($aResult, 0)
			EndIf
			Return $aResult
		Else
			MsgBox(0+16, " SQLite: " & $iRval, _SQLite_ErrMsg ())
		EndIf
	EndIf
EndFunc ; ==> _GetInfoFromDataBase

Func _ExitProg ()
	_CommCloseport()
	_SQLite_Close($hDataBase)
	_SQLite_Shutdown()
	Exit
EndFunc ; _ExitProg